// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlBindingGroup")]
    pub struct BindingGroup(Object<ffi::DzlBindingGroup, ffi::DzlBindingGroupClass>);

    match fn {
        type_ => || ffi::dzl_binding_group_get_type(),
    }
}

impl BindingGroup {
    #[doc(alias = "dzl_binding_group_new")]
    pub fn new() -> BindingGroup {
        assert_initialized_main_thread!();
        unsafe { from_glib_full(ffi::dzl_binding_group_new()) }
    }

    #[doc(alias = "dzl_binding_group_bind")]
    pub fn bind(
        &self,
        source_property: &str,
        target: &impl IsA<glib::Object>,
        target_property: &str,
        flags: glib::BindingFlags,
    ) {
        unsafe {
            ffi::dzl_binding_group_bind(
                self.to_glib_none().0,
                source_property.to_glib_none().0,
                target.as_ref().to_glib_none().0,
                target_property.to_glib_none().0,
                flags.into_glib(),
            );
        }
    }

    //#[doc(alias = "dzl_binding_group_bind_full")]
    //pub fn bind_full(&self, source_property: &str, target: &impl IsA<glib::Object>, target_property: &str, flags: glib::BindingFlags, transform_to: Option<Box_<dyn Fn(&glib::Binding, &glib::Value, &glib::Value) -> bool + 'static>>, transform_from: Option<Box_<dyn Fn(&glib::Binding, &glib::Value, &glib::Value) -> bool + 'static>>) {
    //    unsafe { TODO: call ffi:dzl_binding_group_bind_full() }
    //}

    #[doc(alias = "dzl_binding_group_bind_with_closures")]
    pub fn bind_with_closures(
        &self,
        source_property: &str,
        target: &impl IsA<glib::Object>,
        target_property: &str,
        flags: glib::BindingFlags,
        transform_to: Option<&glib::Closure>,
        transform_from: Option<&glib::Closure>,
    ) {
        unsafe {
            ffi::dzl_binding_group_bind_with_closures(
                self.to_glib_none().0,
                source_property.to_glib_none().0,
                target.as_ref().to_glib_none().0,
                target_property.to_glib_none().0,
                flags.into_glib(),
                transform_to.to_glib_none().0,
                transform_from.to_glib_none().0,
            );
        }
    }

    #[doc(alias = "dzl_binding_group_get_source")]
    #[doc(alias = "get_source")]
    pub fn source(&self) -> Option<glib::Object> {
        unsafe { from_glib_none(ffi::dzl_binding_group_get_source(self.to_glib_none().0)) }
    }

    #[doc(alias = "dzl_binding_group_set_source")]
    pub fn set_source(&self, source: Option<&impl IsA<glib::Object>>) {
        unsafe {
            ffi::dzl_binding_group_set_source(
                self.to_glib_none().0,
                source.map(|p| p.as_ref()).to_glib_none().0,
            );
        }
    }

    #[doc(alias = "source")]
    pub fn connect_source_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_source_trampoline<F: Fn(&BindingGroup) + 'static>(
            this: *mut ffi::DzlBindingGroup,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::source\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_source_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl Default for BindingGroup {
    fn default() -> Self {
        Self::new()
    }
}

impl fmt::Display for BindingGroup {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("BindingGroup")
    }
}
